﻿
Imports Microsoft.DirectX.DirectSound
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.IO
Imports System.Threading

Public Class Form

    Dim BaseAttiva As Short = 99 ' base inesistente
    Dim Toccato As Boolean
    Dim Distrutto As Boolean
    Dim Navicella As Integer
    Dim PotenzaLaterale As Double
    Dim PotenzaAscesa As Double
    Dim PotenzaBooster As Double
    Dim RazzoNegativo As Double
    Dim Gravita As Double
    Dim MaxVelocita As Double
    Dim Carburante As Double ' max 1500 min 0
    Dim Resa As Double 'rendimento motori
    Dim TempoSosta As Double
    Dim CarburanteGuadagnato As Double
    Dim Precisione As Short
    Dim Punteggio As Long
    Dim NomeGiocatore As String
    Dim x As Double
    Dim y As Double
    Dim VelX As Integer
    Dim VelY As Double
    Dim Gas1 As Integer
    Dim Gas2 As Integer
    Dim GasLaterale As Double
    Dim VelocitaAtterraggio As Double
    Dim Caricato As Boolean
    Dim DirectoryDelProgramma As String
    Dim Livello As Long
    Dim Rnd As New Random()
    Dim ImgLivello As Bitmap ' ci copio il paesaggioX per controllo collisione: ColorePixel = ImgLivello.GetPixel(x,y)
    Dim ColorePixel As Color ' se è nero -16777216, nessuna collisione
    Dim BasePen As New Pen(Brushes.Yellow, 6) ' disegno base
    Dim CarburantePen As New Pen(Brushes.Green, 7) ' disegno barra carburante
    Dim AllPen As New Pen(Brushes.Transparent, 2) ' disegno allineamento
    Dim qPen As New Pen(Brushes.Gray, 1) ' disegno quota base
    Dim PrintFont = New Font("Microsoft san serif", 8) ' e.Graphics.DrawString(Info, PrintFont, Brushes.Blue, CInt(x + 60), CInt(y))
    Dim Info As String ' parametri di volo
    Dim ani As Integer = 0 ' ciclo animazione esplosione
    Dim CoordinateBasi(,) As Integer = {{90, 576},
                                       {230, 454},
                                       {435, 241},
                                       {527, 345},
                                       {700, 454},
                                       {818, 493},
                                       {920, 481},
                                       {1020, 584}}


    Dim buff1 As SecondaryBuffer
    Dim buff2 As SecondaryBuffer
    Dim buff3 As SecondaryBuffer
    Dim buff4 As SecondaryBuffer


    Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Integer) As Short ' leggo la pressione di più tasti simultanei

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' creazione e impostazione di 4 buffer audio DirectSound da 0.2 secondi
        Dim wvFormat As New Microsoft.DirectX.DirectSound.WaveFormat
        DS = New Microsoft.DirectX.DirectSound.Device
        DS.SetCooperativeLevel(Me, CooperativeLevel.Normal)
        wvFormat.FormatTag = WaveFormatTag.Pcm
        wvFormat.Channels = 1
        wvFormat.SamplesPerSecond = SRATE
        wvFormat.BitsPerSample = 16
        wvFormat.AverageBytesPerSecond = 2 * SRATE
        wvFormat.BlockAlign = 2
        dsDesc = New BufferDescription(wvFormat)
        dsDesc.BufferBytes = 2 * dur * SRATE
        dsDesc.Flags = 0
        dsDesc.ControlFrequency = True
        dsDesc.ControlPan = True
        dsDesc.ControlVolume = True
        dsDesc.GlobalFocus = False
        dsDesc.StaticBuffer = False
        buff1 = PlayNoise()
        buff1.Frequency = 15000
        buff2 = PlayNoise()
        buff2.Frequency = 4000
        buff3 = PlayWave(120)
        buff4 = PlayWave(5000)
        buff1.Play(0, Microsoft.DirectX.DirectSound.BufferPlayFlags.Looping)
        buff4.Play(0, Microsoft.DirectX.DirectSound.BufferPlayFlags.Looping)
        buff2.Play(0, Microsoft.DirectX.DirectSound.BufferPlayFlags.Looping)
        buff3.Play(0, Microsoft.DirectX.DirectSound.BufferPlayFlags.Looping)
        buff1.Volume = -10000
        buff2.Volume = -10000
        buff3.Volume = -10000
        buff4.Volume = -10000
        ' fine impostazione audio, i 4 buffer sono sempre in Playloop ma a volume zero

        Livello = 1
        ImpostaLivello(Livello)
        PictScena.Width = ImgLivello.Width
        PictScena.Height = ImgLivello.Height
        Me.Width = PictScena.Width + 16
        Me.Height = PictScena.Height + 35
        Me.Text = "Allunaggio CB©2018"
        DirectoryDelProgramma = Application.StartupPath
        VelY = 1 ' velocità iniziale
        Gravita = 0.25 'Gravità
        lblGravita.Text = " Gravità " & Format(Gravita, "0.00") & " G."
        scrollGravita.Value = Gravita * 100
        PotenzaLaterale = 2 ' razzi laterali
        scrollLaterale.Value = PotenzaLaterale
        lblLaterale.Text = Format(PotenzaLaterale, "0.00") & " kN."
        PotenzaAscesa = 0.03 'razzo ascensionale
        scrollGas.Value = PotenzaAscesa * 100
        PotenzaBooster = PotenzaAscesa  ' booster
        RazzoNegativo = PotenzaAscesa * 0.1 ' potenza razzo discenzionale
        lblgas.Text = Format(PotenzaAscesa * 1000, "0.00") & " kN."

        MaxVelocita = 0.5  ' velocità massima consentita di allunaggio
        scrollMassimi.Value = MaxVelocita * 10
        LblMassimi.Text = Format(MaxVelocita * 10, "0.0") & " Allunaggio Max velocità m/s."

        x = 40 ' coordinate di partenza
        y = 40

        Carburante = 265 ' carburante di partenza
        lblCarburante.Text = "Carburante = " & Format(Carburante, "0.00")

        lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " - Livello: " & Livello
        Timer1.Enabled = False
        Timer2.Enabled = Not Timer1.Enabled
        Navicella = 1
        lblinfo.Text = "Navicella N. " & Navicella.ToString & " Premi [CTRL] per giocare."

        GeneraPiattaforme() ' genera le piattaforme e inizializza alcune variabili
        Caricato = False ' fa funzionare form1_keydown
        Distrutto = True ' fa funzionare form1_keydown
        Timer1.Enabled = False ' timer principale

    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode = Keys.P Then Pausa()

        If System.Environment.TickCount - TempoSosta < 1000 Then Exit Sub ' disabilita la tastiera per 1 secondo dopo l'atterraggio
        If scrollGravita.Enabled = True Then Exit Sub ' si è in pausa
        If e.KeyCode = Keys.ControlKey And Distrutto = True Then ' nuova partita
            Distrutto = False
            Timer1.Enabled = True
            Timer2.Enabled = Not Timer1.Enabled
            Label1.ForeColor = Color.Black
            lblinfo.ForeColor = Color.Black
            lblinfo.Text = "Navicella N. " & Navicella
            PotenzaLaterale = scrollLaterale.Value
            PotenzaAscesa = scrollGas.Value / 100
            PotenzaBooster = PotenzaAscesa
            RazzoNegativo = PotenzaAscesa * 0.1
        End If
        If e.KeyCode = Keys.ControlKey And Toccato = True Then ' decollo
            GeneraPiattaforme()
            Toccato = False
            lblinfo.Text = "Navicella N. " & Navicella
            TempoSosta = System.Environment.TickCount
            Timer1.Enabled = True
            Timer2.Enabled = Not Timer1.Enabled
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Static audioOnBeep As Boolean ' beep
        Static audioOnPrecipita As Boolean ' mancanza carburante

        Punteggio = Punteggio + (Livello)
        lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " - Livello: " & Livello
        If Carburante > 1 Then

            If GetAsyncKeyState(Keys.Left) Then 'TastoSinistra
                VelX -= PotenzaLaterale
                GasLaterale = PotenzaLaterale
                buff1.Volume = -1500
                buff4.Volume = -4000
                buff1.Pan = 10000
            ElseIf GetAsyncKeyState(Keys.Right) Then 'Tastodestra
                VelX += PotenzaLaterale
                GasLaterale = PotenzaLaterale * -1
                buff1.Volume = -1500
                buff4.Volume = -4000
                buff1.Pan = -10000
            Else ' no tasti
                GasLaterale = 0
                buff1.Volume = -10000
                buff4.Volume = -10000
            End If

            If GetAsyncKeyState(Keys.Up) And GetAsyncKeyState(Keys.ControlKey) Then ' TastoSu e CTRL
                Gas2 = PotenzaAscesa * 100
                Gas1 = PotenzaBooster * 100
                VelY = VelY - PotenzaAscesa
                VelY = VelY - PotenzaBooster
                buff2.Volume = -1
                buff3.Volume = -100
            ElseIf GetAsyncKeyState(Keys.ControlKey) Then ' CTRL
                Gas1 = PotenzaBooster * 150
                VelY = VelY - PotenzaBooster
                Debug.Print(Gas1 & " - " & VelY)
                Gas2 = 0
                buff2.Volume = -500
                buff3.Volume = -400
            ElseIf GetAsyncKeyState(Keys.Up) Then ' TastoSu
                Gas2 = PotenzaAscesa * 100
                Gas1 = 0
                VelY = VelY - PotenzaAscesa
                buff2.Volume = -600
                buff3.Volume = -10000
            ElseIf GetAsyncKeyState(Keys.Down) Then ' TastoGiu
                VelY = VelY + RazzoNegativo
                Gas2 = RazzoNegativo * -100
                buff3.Volume = -1000
            Else ' no tasti
                Gas2 = 0
                Gas1 = 0
                buff2.Volume = -10000
                buff3.Volume = -10000
            End If

        End If

        If GetAsyncKeyState(Keys.V) Then ' visualizza il pilot
            qPen.Color = Me.BackColor
        Else
            qPen.Color = Color.Transparent ' nasconde il pilot
        End If

        If Toccato = False Then
            VelY += Gravita / 10 + Math.Abs(VelY * Gravita / 30) ' accelerazione di gravità, non proprio corretta
        End If

        y = y + VelY
        x = x + VelX / 100
        If x < 1 Then x = 1 : VelX = 0 ' bordi pictscena
        If x > 1110 Then x = 1110 : VelX = 0

        Carburante = Carburante - ((Gas1 / Resa) + (Gas2 / Resa) + Math.Abs(GasLaterale / Resa)) ' consumo carburante

        If Carburante < 1 Then
            buff1.Volume = -10000
            buff2.Volume = -10000
            buff3.Volume = -10000
            buff4.Volume = -10000
            If audioOnPrecipita = False Then
                My.Computer.Audio.Stop()
                My.Computer.Audio.Play(My.Resources.precipita, AudioPlayMode.Background)
                audioOnPrecipita = True
            End If
            lblinfo.Text = "Manca il carburante !"
            Gas1 = 0
            Gas2 = 0
            GasLaterale = 0
            PotenzaLaterale = 0
            PotenzaAscesa = 0
            PotenzaBooster = 0
            RazzoNegativo = 0
            Carburante = 0
            lblCarburante.Text = "Carburante = " & Format(Carburante, "0.00")
        Else
            If Carburante < 200 Then
                CarburantePen = New Pen(Brushes.Red, 7)
                If audioOnBeep = False Then My.Computer.Audio.PlaySystemSound(Media.SystemSounds.Hand)
                audioOnBeep = True
            Else
                CarburantePen = New Pen(Brushes.Green, 7)
                audioOnBeep = False
            End If
            lblCarburante.Text = "Carburante = " & Format(Carburante, "0.00")
        End If

        If y > 0 Then ColorePixel = ImgLivello.GetPixel(CInt(x + 5), CInt(y + 59)) ' non controllo se la navicella è troppo in alto
        ' Debug.Print(ColorePixel.ToArgb)
        If ColorePixel.ToArgb = -16777216 Then ' controllo a sinistra se c'è il nero
            If y > 0 Then ColorePixel = ImgLivello.GetPixel(CInt(x + 45), CInt(y + 59)) ' non controllo se la navicella è troppo in alto
            ' Debug.Print(ColorePixel.ToArgb)
            If ColorePixel.ToArgb = -16777216 Then ' controllo a destra se c'è il nero
                If x > CoordinateBasi(BaseAttiva, 0) - 18 And x < CoordinateBasi(BaseAttiva, 0) + 44 - 33 Then ' range accettato per la precisione di atterraggio
                    AllPen = New Pen(Brushes.LightBlue, 6) ' mostro la righetta di allineamento, la coordinata x è all'interno della base
                    If y + 69 > CoordinateBasi(BaseAttiva, 1) Then ' si è superata la coordinata y della base
                        If VelY > MaxVelocita Then ' massima velocità consentinta di atterraggio
                            Distrutto = True
                            Toccato = False
                            lblinfo.Text = "Distrutto ! troppo veloce ! - PREMI [CTRL]"
                            Timer1.Enabled = False
                            Timer2.Enabled = Not Timer1.Enabled
                            Distruzione()
                            Livello = 1
                            lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " - Livello: " & Livello
                            ImpostaLivello(Livello)
                        Else
                            If Toccato = False Then VelocitaAtterraggio = VelY 'salvo il valore della velocità prima di azzerarlo
                            VelY = 0
                            VelX = 0
                            Gas1 = 0
                            Gas2 = 0
                            GasLaterale = 0
                            Toccato = True ' notifico che la navicella ha toccato la base
                            Distrutto = False ' con una velocità adeguata
                            buff1.Volume = -10000
                            buff2.Volume = -10000
                            buff3.Volume = -10000
                            buff4.Volume = -10000
                        End If
                    Else
                        Toccato = False
                    End If
                Else
                    AllPen = New Pen(Brushes.Transparent, 2)
                End If
            Else
                'distruzione toccato a destra
                lblinfo.Text = "Distrutto ! Hai toccato il monte ! - PREMI [CTRL]"
                Distruzione()
                audioOnPrecipita = False
            End If
        Else
            'distruzione toccato a sinistra
            lblinfo.Text = "Distrutto ! Hai toccato il monte ! - PREMI [CTRL]"
            Distruzione()
            audioOnPrecipita = False
        End If

        Dim deltaX As String = ""
        Dim deltaY As String = ""

        ' si potrebbe costruire una strumentazione ad hoc
        Select Case VelX
            Case Is < 0
                deltaX = "< "
            Case Is = 0
                deltaX = "● "
            Case Is > 0
                deltaX = "> "
        End Select

        If VelY > 0 Then
            deltaY = "٧ "
        Else
            deltaY = "٨ "
        End If

        Info = deltaY & Format(Math.Abs(VelY * 10), "00.00") & " m/s" & vbNewLine & _
        deltaX & Format(Math.Abs(VelX / 10), "00.00") & " m/s" & vbNewLine & _
        "AL " & Format(Math.Abs((CoordinateBasi(BaseAttiva, 1) - y - 69) / 10), "00.00") & " m" & vbNewLine & _
        "Mt " & Format((Gas1 + Gas2) * 10, "00.00") & " kN." & vbNewLine & _
        "La " & Format(Math.Abs(GasLaterale), "00.00") & " kN."

        lblParametri.Text = Info
        '-----------------------------------------------

        PictScena.Refresh() ' Richiama il paint

        If System.Environment.TickCount - TempoSosta < 100 Then Exit Sub ' quando si decolla si saltano tutti icontrolli di collisione

        If Toccato = True Then
            If VelocitaAtterraggio < 0.1 Then VelocitaAtterraggio = 0.1 ' serve per non fare una divisione che poi darà carburante esagerato
            ' Debug.Print("Atterrato.. Velocità = " & VelocitaAtterraggio)
            Timer1.Enabled = False
            Timer2.Enabled = Not Timer1.Enabled

            Precisione = Math.Abs(CoordinateBasi(BaseAttiva, 0) - x - 3)
            If Precisione = 0 Then
                CarburanteGuadagnato = 40 / VelocitaAtterraggio + 200
            Else
                CarburanteGuadagnato = 40 / VelocitaAtterraggio + 100 / Precisione
            End If

            lblinfo.Text = "Velocità " & Math.Round(VelocitaAtterraggio * 10, 2) & " m/s. errore = " & Precisione * 10 & " Cm. - PREMI [CTRL] per ripartire - oil + " & Math.Round(CarburanteGuadagnato, 2)
            Carburante += CarburanteGuadagnato
            If Carburante > 1000 Then ' passaggio di livello
                Carburante = 1000
                Livello = Livello + 1
                lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " - Livello: " & Livello
                ImpostaLivello(Livello)
            End If
            Punteggio = Punteggio + CInt(CarburanteGuadagnato)
            lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " - Livello: " & Livello
            TempoSosta = System.Environment.TickCount ' memorizzo in che momento si è atterrato
        End If

    End Sub

    Private Sub PictScena_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictScena.Paint

        'disegno tutta la scena
        e.Graphics.DrawLine(qPen, 30, CoordinateBasi(BaseAttiva, 1), 1130, CoordinateBasi(BaseAttiva, 1)) ' pilot orizzontale
        e.Graphics.DrawLine(qPen, CInt(x + 24), CInt(y + 70), CInt(x + 24), CoordinateBasi(BaseAttiva, 1) + 15) ' pilot verticale
        e.Graphics.DrawLine(BasePen, CoordinateBasi(BaseAttiva, 0), CoordinateBasi(BaseAttiva, 1), CoordinateBasi(BaseAttiva, 0) + 21, CoordinateBasi(BaseAttiva, 1)) ' base tratto sinistro
        e.Graphics.DrawLine(BasePen, CoordinateBasi(BaseAttiva, 0) + 23, CoordinateBasi(BaseAttiva, 1), CoordinateBasi(BaseAttiva, 0) + 44, CoordinateBasi(BaseAttiva, 1)) ' base tratto destro
        e.Graphics.DrawLine(AllPen, CInt(x + 24), CoordinateBasi(BaseAttiva, 1), CInt(x + 26), CoordinateBasi(BaseAttiva, 1)) ' allineamento
        e.Graphics.DrawLine(CarburantePen, 40, 616, CInt(40 + Carburante), 616) ' barra carburante
        e.Graphics.DrawImage(ImageNavicelle.Images(2), CInt(x + GasLaterale * Math.Log10(50000)), CInt(y)) ' getti laterali
        e.Graphics.DrawImage(ImageNavicelle.Images(1), CInt(x), CInt(y + (Gas1 + Gas2) * 1.5)) ' getti inferiori
        e.Graphics.DrawImage(ImageNavicelle.Images(ani), CInt(x), CInt(y)) ' navicella
        e.Graphics.DrawString(Info, PrintFont, Brushes.MediumSlateBlue, CInt(x + 60), CInt(y)) ' etichetta info

    End Sub

    Private Sub Pausa()

        If scrollGravita.Enabled = False Then
            Timer1.Enabled = False
            Timer2.Enabled = Not Timer1.Enabled
            scrollGravita.Enabled = True
            scrollGas.Enabled = True
            scrollLaterale.Enabled = True
            scrollMassimi.Enabled = True
            cmdCarica.Enabled = True
            CmdSalva.Enabled = True
            lblinfo.Text = "Pausa, puoi cambiare i parametri.[P] per tornare al gioco"
            Distrutto = True
            Caricato = True
        Else
            If Toccato = False And Distrutto = False Then Timer1.Enabled = True : Timer2.Enabled = Not Timer1.Enabled
            scrollGravita.Enabled = False
            scrollGas.Enabled = False
            scrollLaterale.Enabled = False
            scrollMassimi.Enabled = False
            cmdCarica.Enabled = False
            CmdSalva.Enabled = False
            lblinfo.ForeColor = Color.Black
            If Caricato = True Then
                Caricato = False
                If Toccato = True Then
                    lblinfo.Text = "Premi [CTRL] per ripartire."
                Else
                    If Distrutto = True Then
                        lblinfo.Text = "Premi [CTRL] per giocare."
                    Else
                        lblinfo.Text = "Navicella N. " & Navicella
                    End If
                End If
            End If
        End If

    End Sub

    Sub GeneraPiattaforme()

        Dim NuovaBase As Short = BaseAttiva

        Do
            BaseAttiva = Rnd.Next(0, 8) ' selgo una base divarsa da dove si è atterrati
        Loop While NuovaBase = BaseAttiva

        PictScena.Refresh()
        My.Computer.Audio.PlaySystemSound(Media.SystemSounds.Asterisk)
        PotenzaLaterale = scrollLaterale.Value
        PotenzaAscesa = scrollGas.Value / 100
        PotenzaBooster = PotenzaAscesa
        RazzoNegativo = PotenzaAscesa * 0.1

    End Sub

    Sub ImpostaLivello(ByVal LivelloAttuale As Short)

        Select Case LivelloAttuale
            Case 1
                PictScena.BackgroundImage = My.Resources.paesaggio1
                PictScena.Image = My.Resources.grafiche
                ImgLivello = My.Resources.paesaggio1
                Resa = 15
            Case 2
                PictScena.BackgroundImage = My.Resources.paesaggio2
                PictScena.Image = My.Resources.grafiche
                ImgLivello = My.Resources.paesaggio2
                Resa = 12
            Case 3
                PictScena.BackgroundImage = My.Resources.paesaggio3
                PictScena.Image = My.Resources.grafiche
                ImgLivello = My.Resources.paesaggio3
                Resa = 10
            Case 4
                PictScena.BackgroundImage = My.Resources.paesaggio4
                PictScena.Image = My.Resources.grafiche
                ImgLivello = My.Resources.paesaggio4
                Resa = 9
            Case Else
                PictScena.BackgroundImage = My.Resources.paesaggio5
                PictScena.Image = My.Resources.grafiche
                ImgLivello = My.Resources.paesaggio5
                Resa = 7 - (Livello - 5)
        End Select

        Me.BackColor = ImgLivello.GetPixel(10, 600) 'le label sono trasparenti, lasciano vedere il colore di sfondo del form 
        qPen.Color = Color.Transparent ' nascondo il pilot
        qPen.DashPattern = New Single() {1.0F, 6.0F}
        qPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Custom

    End Sub

    Private Sub Distruzione()

        Timer1.Enabled = False
        Timer2.Enabled = Not Timer1.Enabled
        buff1.Volume = -10000
        buff2.Volume = -10000
        buff3.Volume = -10000
        buff4.Volume = -10000
        My.Computer.Audio.Play(My.Resources.esplosione, AudioPlayMode.Background)
        For Me.ani = 3 To 8
            PictScena.Refresh()
            Thread.Sleep(20)
        Next
        ani = 0
        VelX = 0
        VelY = 0
        Navicella += 1
        Distrutto = True
        x = 40
        y = 40
        Gas1 = 0
        Gas2 = 0
        GasLaterale = 0
        Carburante = 265
        AllPen.Color = Color.Transparent ' nasondo la barretta di allineamento
        TempoSosta = System.Environment.TickCount ' memorizzo in che momento si è schiantato
    End Sub

    Private Sub scrollGas_Change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollGas.Scroll

        PotenzaAscesa = scrollGas.Value / 100
        lblgas.Text = Format(PotenzaAscesa * 1000, "0.00") & " kN."
        PotenzaBooster = PotenzaAscesa  ' booster
        RazzoNegativo = PotenzaAscesa * 0.1 ' potenza razzo discenzionale

    End Sub

    Private Sub scrollGas_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollGas.Scroll

        PotenzaAscesa = scrollGas.Value / 100
        lblgas.Text = Format(PotenzaAscesa * 1000, "0.00") & " kN."
        PotenzaBooster = PotenzaAscesa  ' booster
        RazzoNegativo = PotenzaAscesa * 0.1 ' potenza razzo discenzionale

    End Sub

    Private Sub scrollGravita_Change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollGravita.Scroll

        Gravita = scrollGravita.Value / 100
        lblGravita.Text = " Gravità " & Format(Gravita, "0.00") & " g."

    End Sub

    Private Sub scrollGravita_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollGravita.Scroll

        Gravita = scrollGravita.Value / 100
        lblGravita.Text = " Gravità " & Format(Gravita, "0.00") & " g."

    End Sub

    Private Sub scrollLaterale_Change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollLaterale.Scroll

        PotenzaLaterale = scrollLaterale.Value
        lblLaterale.Text = Format(PotenzaLaterale, "0.00") & " kN."

    End Sub

    Private Sub scrollLaterale_Scroll_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollLaterale.Scroll

        PotenzaLaterale = scrollLaterale.Value
        lblLaterale.Text = Format(PotenzaLaterale, "0.00") & " kN."

    End Sub

    Private Sub scrollMassimi_Change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollMassimi.Scroll

        MaxVelocita = scrollMassimi.Value / 10
        LblMassimi.Text = Format(MaxVelocita * 10, "0.0") & " Allunaggio Max velocità m/s."

    End Sub

    Private Sub scrollMassimi_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles scrollMassimi.Scroll

        MaxVelocita = scrollMassimi.Value / 10
        LblMassimi.Text = Format(MaxVelocita * 10, "0.0") & " Allunaggio Max velocità m/s."

    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Static blink As Boolean 'lampeggio label

        blink = Not blink

        If blink Then
            lblinfo.ForeColor = Color.Black
        Else
            lblinfo.ForeColor = Color.White
        End If
    End Sub

    Private Sub cmdCarica_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCarica.Click

        Dim NomePartita As String
        Dim Dati(22) As String
        Dim i As Integer
        OpenFileDialog1.Title = "Carica le partite salvate"
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.InitialDirectory = DirectoryDelProgramma
        OpenFileDialog1.Filter = "Scena.txt|*.txt"
        OpenFileDialog1.ShowDialog()
        NomePartita = OpenFileDialog1.FileName
        If NomePartita = "" Then Exit Sub

        Debug.Print("Leggo dal file """ & NomePartita & " la scena salvata")
        Dim SequenzeInFile As System.IO.StreamReader
        SequenzeInFile = My.Computer.FileSystem.OpenTextFileReader(NomePartita)
        Dim Letto As String = ""

        For i = 1 To 22
            Letto = SequenzeInFile.ReadLine()
            Debug.Print("Letto nel file " & Letto)
            Dati(i) = Letto
        Next i
        SequenzeInFile.Close()

        Navicella = CInt(Dati(1))
        VelY = CDbl(Dati(2))
        BaseAttiva = CInt(Dati(3))
        Livello = CLng(Dati(4))
        If UCase(Dati(5)) = "FALSO" Or UCase(Dati(5)) = "FALSE" Then Toccato = False
        If UCase(Dati(5)) = "TRUE" Or UCase(Dati(5)) = "VERO" Then Toccato = True
        If UCase(Dati(6)) = "FALSO" Or UCase(Dati(6)) = "FALSE" Then Distrutto = False
        If UCase(Dati(6)) = "TRUE" Or UCase(Dati(6)) = "VERO" Then Distrutto = True
        PotenzaLaterale = CDbl(Dati(7))
        scrollLaterale.Value = PotenzaLaterale
        lblLaterale.Text = Format(PotenzaLaterale, "0.00") & " kN."
        PotenzaAscesa = CDbl(Dati(8))
        scrollGas.Value = PotenzaAscesa * 100
        PotenzaBooster = PotenzaAscesa  ' booster
        RazzoNegativo = PotenzaAscesa * 0.1 ' potenza razzo discenzionale
        lblgas.Text = Format(PotenzaAscesa * 1000, "0.00") & " kN."
        Gravita = CDbl(Dati(11))
        lblGravita.Text = " Gravità " & Format(Gravita, "0.00") & " G."
        scrollGravita.Value = Gravita * 100
        MaxVelocita = CDbl(Dati(12))
        scrollMassimi.Value = MaxVelocita * 10
        LblMassimi.Text = Format(MaxVelocita * 10, "0.0") & " Allunaggio Max velocità m/s."
        Carburante = CDbl(Dati(13))
        CarburanteGuadagnato = CDbl(Dati(16))
        Punteggio = CLng(Dati(17))
        NomeGiocatore = Dati(18)
        x = CDbl(Dati(19))
        y = CDbl(Dati(20))
        VelX = CDbl(Dati(21))
        VelocitaAtterraggio = CDbl(Dati(22))

        ImpostaLivello(Livello)

        lblPunti.Text = " Punteggio: " & Format(Punteggio, "00000000") & " ( L " & Livello & " )"

        If Toccato = True And Distrutto = False Then
            lblinfo.Text = "Velocità " & Math.Round(VelocitaAtterraggio, 2) & " - PREMI [P] poi [CTRL] per ripartire - oil + " & Math.Round(CarburanteGuadagnato, 2)
            TempoSosta = System.Environment.TickCount
        Else
            If Distrutto = True Then
                lblinfo.Text = "Distrutto! Navicella N. " & Navicella & " - PREMI [P] poi [CTRL] per giocare"
            Else
                lblinfo.Text = "Navicella N. " & Navicella & " - PREMI [P] per giocare"
            End If
        End If

        Dim deltaX As String = ""
        Dim deltaY As String = ""

        Select Case VelX
            Case Is < 0
                deltaX = "< "
            Case Is = 0
                deltaX = "● "
            Case Is > 0
                deltaX = "> "
        End Select

        If VelY > 0 Then
            deltaY = "٧ "
        Else
            deltaY = "٨ "
        End If

        lblParametri.Text = deltaY & Format(Math.Abs(VelY * 10), "00.00") & " m/s" & vbNewLine & _
             deltaX & Format(Math.Abs(VelX / 10), "00.00") & " m/s" & vbNewLine & _
             "AL " & Format(Math.Abs((CoordinateBasi(BaseAttiva, 1) - y - 69) / 10), "00.00") & " m" & vbNewLine & _
             "Mt " & Format(0, "00.00") & " kN." & vbNewLine & _
             "La " & Format(0, "00.00") & " kN."

        If Carburante < 200 Then
            CarburantePen = New Pen(Brushes.Red, 7)
        Else
            CarburantePen = New Pen(Brushes.Green, 7)
        End If
        lblCarburante.Text = "Carburante = " & Format(Carburante, "0.00")

        Caricato = True

    End Sub

    Private Sub CmdSalva_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSalva.Click

        Dim NomePartita As String
        Dim Dati(22) As String

        SaveFileDialog1.Filter = "Scena|*.txt"
        SaveFileDialog1.InitialDirectory = DirectoryDelProgramma
        SaveFileDialog1.ShowDialog()
        NomePartita = SaveFileDialog1.FileName
        If NomePartita = "" Then Exit Sub

        Dati(1) = CStr(Navicella)
        Dati(2) = CStr(VelY)
        Dati(3) = CStr(BaseAttiva)
        Dati(4) = CStr(Livello)
        Dati(5) = CStr(Toccato)
        Dati(6) = CStr(Distrutto)
        Dati(7) = CStr(PotenzaLaterale)
        Dati(8) = CStr(PotenzaAscesa)
        Dati(9) = CStr(PotenzaBooster)
        Dati(10) = CStr(RazzoNegativo)
        Dati(11) = CStr(Gravita)
        Dati(12) = CStr(MaxVelocita)
        Dati(13) = CStr(Carburante)
        Dati(14) = CStr(Resa)
        Dati(15) = CStr(TempoSosta)
        Dati(16) = CStr(CarburanteGuadagnato)
        Dati(17) = CStr(Punteggio)
        Dati(18) = NomeGiocatore
        Dati(19) = CStr(x)
        Dati(20) = CStr(y)
        Dati(21) = CStr(VelX)
        Dati(22) = CStr(VelocitaAtterraggio)

        Dim SequenzeInFile As System.IO.StreamWriter ' preparo per la scrittura del file
        If My.Computer.FileSystem.FileExists(NomePartita) Then My.Computer.FileSystem.DeleteFile(NomePartita) ' se il file esiste lo cancello
        SequenzeInFile = My.Computer.FileSystem.OpenTextFileWriter(NomePartita, True) ' apro un file in scrittura, sempre con lo stesso nome

        ' scrivo il file da zero
        Dim Volte As Integer
        For Volte = 1 To 22
            SequenzeInFile.WriteLine(Dati(Volte))
        Next Volte
        SequenzeInFile.Close() ' chiudo il file

    End Sub

End Class