﻿
Module directSnd

    Public Const SRATE As Integer = 44100 ' 
    Public Const Dur As Double = 0.2
    Public dsDesc As BufferDescription
    Public wvFormat As WaveFormat
    Public DS As Device

    Function PlayNoise() As SecondaryBuffer
        ' create a buffer
        Dim dsBuffer As SecondaryBuffer
        dsBuffer = New SecondaryBuffer(dsDesc, DS)
        Dim sbuf(Dur * SRATE) As Short

        ' create noise  
        For i = 0 To Dur * SRATE
            sbuf(i) = Rnd(1) * 4500
        Next

        ' copy to buffer
        dsBuffer.Write(0, sbuf, LockFlag.EntireBuffer)
        Return dsBuffer

    End Function


    Function PlayWave(ByVal FREQ As Double) As SecondaryBuffer
        ' create a buffer
        Dim dsBuffer As SecondaryBuffer
        dsBuffer = New SecondaryBuffer(dsDesc, DS)
        Dim sbuf(Dur * SRATE) As Short

        ' create tone                
        For i As Integer = 0 To Dur * SRATE
            sbuf(i) = CShort(10000 * Math.Sin(2 * Math.PI * FREQ * i / SRATE))
        Next

        ' copy to buffer
        dsBuffer.Write(0, sbuf, LockFlag.EntireBuffer)
        Return dsBuffer
    End Function
End Module